Merge branch 'sg/travis-gcc-4.8'
[git/git.git] / ci / lib.sh
1 # Library of functions shared by all CI scripts
2
3 skip_branch_tip_with_tag () {
4 # Sometimes, a branch is pushed at the same time the tag that points
5 # at the same commit as the tip of the branch is pushed, and building
6 # both at the same time is a waste.
7 #
8 # When the build is triggered by a push to a tag, $CI_BRANCH will
9 # have that tagname, e.g. v2.14.0. Let's see if $CI_BRANCH is
10 # exactly at a tag, and if so, if it is different from $CI_BRANCH.
11 # That way, we can tell if we are building the tip of a branch that
12 # is tagged and we can skip the build because we won't be skipping a
13 # build of a tag.
14
15 if TAG=$(git describe --exact-match "$CI_BRANCH" 2>/dev/null) &&
16 test "$TAG" != "$CI_BRANCH"
17 then
18 echo "$(tput setaf 2)Tip of $CI_BRANCH is exactly at $TAG$(tput sgr0)"
19 exit 0
20 fi
21 }
22
23 # Save some info about the current commit's tree, so we can skip the build
24 # job if we encounter the same tree again and can provide a useful info
25 # message.
26 save_good_tree () {
27 echo "$(git rev-parse $CI_COMMIT^{tree}) $CI_COMMIT $CI_JOB_NUMBER $CI_JOB_ID" >>"$good_trees_file"
28 # limit the file size
29 tail -1000 "$good_trees_file" >"$good_trees_file".tmp
30 mv "$good_trees_file".tmp "$good_trees_file"
31 }
32
33 # Skip the build job if the same tree has already been built and tested
34 # successfully before (e.g. because the branch got rebased, changing only
35 # the commit messages).
36 skip_good_tree () {
37 if ! good_tree_info="$(grep "^$(git rev-parse $CI_COMMIT^{tree}) " "$good_trees_file")"
38 then
39 # Haven't seen this tree yet, or no cached good trees file yet.
40 # Continue the build job.
41 return
42 fi
43
44 echo "$good_tree_info" | {
45 read tree prev_good_commit prev_good_job_number prev_good_job_id
46
47 if test "$CI_JOB_ID" = "$prev_good_job_id"
48 then
49 cat <<-EOF
50 $(tput setaf 2)Skipping build job for commit $CI_COMMIT.$(tput sgr0)
51 This commit has already been built and tested successfully by this build job.
52 To force a re-build delete the branch's cache and then hit 'Restart job'.
53 EOF
54 else
55 cat <<-EOF
56 $(tput setaf 2)Skipping build job for commit $CI_COMMIT.$(tput sgr0)
57 This commit's tree has already been built and tested successfully in build job $prev_good_job_number for commit $prev_good_commit.
58 The log of that build job is available at $(url_for_job_id $prev_good_job_id)
59 To force a re-build delete the branch's cache and then hit 'Restart job'.
60 EOF
61 fi
62 }
63
64 exit 0
65 }
66
67 check_unignored_build_artifacts ()
68 {
69 ! git ls-files --other --exclude-standard --error-unmatch \
70 -- ':/*' 2>/dev/null ||
71 {
72 echo "$(tput setaf 1)error: found unignored build artifacts$(tput sgr0)"
73 false
74 }
75 }
76
77 # Clear MAKEFLAGS that may come from the outside world.
78 export MAKEFLAGS=
79
80 # Set 'exit on error' for all CI scripts to let the caller know that
81 # something went wrong.
82 # Set tracing executed commands, primarily setting environment variables
83 # and installing dependencies.
84 set -ex
85
86 if test true = "$TRAVIS"
87 then
88 CI_TYPE=travis
89 # When building a PR, TRAVIS_BRANCH refers to the *target* branch. Not
90 # what we want here. We want the source branch instead.
91 CI_BRANCH="${TRAVIS_PULL_REQUEST_BRANCH:-$TRAVIS_BRANCH}"
92 CI_COMMIT="$TRAVIS_COMMIT"
93 CI_JOB_ID="$TRAVIS_JOB_ID"
94 CI_JOB_NUMBER="$TRAVIS_JOB_NUMBER"
95 CI_OS_NAME="$TRAVIS_OS_NAME"
96 CI_REPO_SLUG="$TRAVIS_REPO_SLUG"
97
98 cache_dir="$HOME/travis-cache"
99
100 url_for_job_id () {
101 echo "https://travis-ci.org/$CI_REPO_SLUG/jobs/$1"
102 }
103
104 BREW_INSTALL_PACKAGES="git-lfs gettext"
105 export GIT_PROVE_OPTS="--timer --jobs 3 --state=failed,slow,save"
106 export GIT_TEST_OPTS="--verbose-log -x --immediate"
107 MAKEFLAGS="$MAKEFLAGS --jobs=2"
108 elif test -n "$SYSTEM_COLLECTIONURI" || test -n "$SYSTEM_TASKDEFINITIONSURI"
109 then
110 CI_TYPE=azure-pipelines
111 # We are running in Azure Pipelines
112 CI_BRANCH="$BUILD_SOURCEBRANCH"
113 CI_COMMIT="$BUILD_SOURCEVERSION"
114 CI_JOB_ID="$BUILD_BUILDID"
115 CI_JOB_NUMBER="$BUILD_BUILDNUMBER"
116 CI_OS_NAME="$(echo "$AGENT_OS" | tr A-Z a-z)"
117 test darwin != "$CI_OS_NAME" || CI_OS_NAME=osx
118 CI_REPO_SLUG="$(expr "$BUILD_REPOSITORY_URI" : '.*/\([^/]*/[^/]*\)$')"
119 CC="${CC:-gcc}"
120
121 # use a subdirectory of the cache dir (because the file share is shared
122 # among *all* phases)
123 cache_dir="$HOME/test-cache/$SYSTEM_PHASENAME"
124
125 url_for_job_id () {
126 echo "$SYSTEM_TASKDEFINITIONSURI$SYSTEM_TEAMPROJECT/_build/results?buildId=$1"
127 }
128
129 BREW_INSTALL_PACKAGES=gcc@8
130 export GIT_PROVE_OPTS="--timer --jobs 10 --state=failed,slow,save"
131 export GIT_TEST_OPTS="--verbose-log -x --write-junit-xml"
132 MAKEFLAGS="$MAKEFLAGS --jobs=10"
133 test windows_nt != "$CI_OS_NAME" ||
134 GIT_TEST_OPTS="--no-chain-lint --no-bin-wrappers $GIT_TEST_OPTS"
135 else
136 echo "Could not identify CI type" >&2
137 exit 1
138 fi
139
140 good_trees_file="$cache_dir/good-trees"
141
142 mkdir -p "$cache_dir"
143
144 skip_branch_tip_with_tag
145 skip_good_tree
146
147 if test -z "$jobname"
148 then
149 jobname="$CI_OS_NAME-$CC"
150 fi
151
152 export DEVELOPER=1
153 export DEFAULT_TEST_TARGET=prove
154 export GIT_TEST_CLONE_2GB=YesPlease
155
156 case "$jobname" in
157 linux-clang|linux-gcc)
158 if [ "$jobname" = linux-gcc ]
159 then
160 export CC=gcc-8
161 fi
162
163 export GIT_TEST_HTTPD=YesPlease
164
165 # The Linux build installs the defined dependency versions below.
166 # The OS X build installs much more recent versions, whichever
167 # were recorded in the Homebrew database upon creating the OS X
168 # image.
169 # Keep that in mind when you encounter a broken OS X build!
170 export LINUX_P4_VERSION="16.2"
171 export LINUX_GIT_LFS_VERSION="1.5.2"
172
173 P4_PATH="$HOME/custom/p4"
174 GIT_LFS_PATH="$HOME/custom/git-lfs"
175 export PATH="$GIT_LFS_PATH:$P4_PATH:$PATH"
176 ;;
177 osx-clang|osx-gcc)
178 if [ "$jobname" = osx-gcc ]
179 then
180 export CC=gcc-8
181 fi
182
183 # t9810 occasionally fails on Travis CI OS X
184 # t9816 occasionally fails with "TAP out of sequence errors" on
185 # Travis CI OS X
186 export GIT_SKIP_TESTS="t9810 t9816"
187 ;;
188 GIT_TEST_GETTEXT_POISON)
189 export GIT_TEST_GETTEXT_POISON=true
190 ;;
191 esac
192
193 MAKEFLAGS="$MAKEFLAGS CC=${CC:-cc}"